package me.hammerle.snuviengine.game;

import me.hammerle.snuviengine.api.ColorRenderer;
import me.hammerle.snuviengine.api.Engine;
import me.hammerle.snuviengine.api.FontRenderer;
import me.hammerle.snuviengine.api.FontRenderer;
import me.hammerle.snuviengine.api.KeyBinding;
import me.hammerle.snuviengine.api.KeyHandler;
import me.hammerle.snuviengine.api.Shader;
import me.hammerle.snuviengine.api.Texture;
import me.hammerle.snuviengine.api.TextureRenderer;
import me.hammerle.snuviengine.util.Clock;
import static org.lwjgl.glfw.GLFW.*;

public class Game extends Engine
{
    private final static KeyBinding UP = KeyHandler.register(GLFW_KEY_W);
    private final static KeyBinding DOWN = KeyHandler.register(GLFW_KEY_S);
    private final static KeyBinding LEFT = KeyHandler.register(GLFW_KEY_A);
    private final static KeyBinding RIGHT = KeyHandler.register(GLFW_KEY_D);
    
    private final ColorRenderer cr = new ColorRenderer();
    private final TextureRenderer tr = new TextureRenderer();
    private final Texture t = new Texture("images/out3.png");
    
    private final FontRenderer fr = new FontRenderer();
    private final Texture text = new Texture("font.png");
    
    float x = 0.0f;
    float y = 0.0f;
    
    int counter = 0;
    
    public Game()
    {
        t.addAnimation(0, 0, "images/water1.png", "images/water2.png", "images/water3.png", "images/water2.png");
    }
    
    @Override
    public void init()
    {
        /*Shader.getMap().getTextureAtlas().addTexture("images/out1.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out2.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out3.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out4.png");
        Shader.getMap().getTextureAtlas().addTexture("images/out5.png");
        
        Shader.getMap().load("test");
        
        Shader.getMap().getAmbientLight().setColor(1.0f, 1.0f, 1.0f);*/
        
        /*Light l = Shader.getMap().getLight(0);
        l.setColor(0.7f, 0.5f, 0.5f);
        l.setStrength(0.005f);
        l.setLocation(100.0f, 100.0f);*/
        
        //Shader.setLightUsing(true);
        Shader.setAmbientLight(0.5f, 0.5f, 0.5f);
        Shader.setLightLocation(0, 100, 100);
        Shader.setLightColor(0, 0.5f, 0.4f, 0.4f);
        Shader.setLightStrength(0, 0.01f);
    }

    @Override
    public void tick()
    {        
        /*if(UP.isDown())
        {
            y += 5;
        }
        if(DOWN.isDown())
        {
            y -= 5;
        }
        if(LEFT.isDown())
        {
            x -= 5;
        }
        if(RIGHT.isDown())
        {
            x += 5;
        }
        Shader.getMap().setCamera(x, y);
        Shader.getMap().getLight(0).setLocation(x + 16, y + 16);*/
        counter++;
        if(counter >= 20)
        {
            counter = 0;
            t.nextFrame();
        }
        
        x += 1f;
    }
    
    private static final Clock clock = new Clock(1000);
    
    @Override
    public void renderTick()
    {
        //Shader.drawMap();
        
        /*Shader.setTextureUsing(false);

        Shader.translateTo(500, 250);
        Shader.scale(5, 5);
        Shader.rotate(x);
        Shader.translate(-10, -10);
        Shader.updateMatrix();
        
        cr.setColor(0.75f, 0.75f, 0.75f, 1.0f);
        cr.addRectangle(0, 0, 20, 20);
        cr.build();
        cr.draw();
        
        Shader.pushMatrix();
        Shader.translate(30, 30);
        Shader.rotate(x);
        Shader.translate(-5, -5);
        Shader.updateMatrix();
        Shader.popMatrix();
        
        cr.setColor(0.5f, 0.5f, 0.5f, 1.0f);
        cr.addRectangle(0, 0, 5, 5);
        cr.build();
        cr.draw();
        
        Shader.pushMatrix();
        Shader.translate(30, 10);
        Shader.rotate(x);
        Shader.translate(-5, -5);
        Shader.updateMatrix();
        Shader.popMatrix();
        
        cr.setColor(0.5f, 1.0f, 0.5f, 1.0f);
        cr.addRectangle(0, 0, 5, 5);
        cr.build();
        cr.draw();*/
        
        clock.start();
        Shader.setColorUsing(false);
        Shader.setTextureUsing(true);
        t.bindTexture();
        for(int i = 0; i < 192; i += 64)
        {
            tr.addRectangle(i, 64, i + 64, 128, 0.0f, 0.0f, 1.0f, 1.0f);
        }
        tr.build();
        tr.draw();
        
        text.bindTexture();
        Shader.setColorUsing(true);
        
        Shader.pushMatrix();
        Shader.translateTo(0.0f, 0.0f);
        //Shader.scale(3, 3);
        Shader.updateMatrix();
        
        for(int i = 0; i < 30; i++)
        {
            fr.drawString(0.0f, i * 16.0f, true, "&üDas &0i&1s&2t &3e&4i&5n &6F&7a&8r&9b&ae&bn&ct&de&es&ft. Das &0i&1s&2t &3e&4i&5n &6F&7a&8r&9b&ae&bn&ct&de&es&ft.");
        }
        
        Shader.popMatrix();
        Shader.updateMatrix();

        clock.stop();
        clock.printTime("Text:");
    }
}
